' O2common.inc
' These are the commonly use functions and macros
' Updated :  Nov 6 2018

uses Corewin

 ' Background color for main window
int  MainWindBGColor

' Trim function
 def Trim ltrim(rtrim(%1))

'  Variant pointer
   def varptr @ %1

 ' PB CODEPTR function
  def codeptr @ %1

'  Carriage return character
   string  cr = chr(13,10)


'  Font Weights 
% FW_DONTCARE   = 0
% FW_THIN       = 100
% FW_EXTRALIGHT = 200
% FW_LIGHT      = 300
% FW_NORMAL     = 400
% FW_MEDIUM     = 500
% FW_SEMIBOLD   = 600
% FW_BOLD       = 700
% FW_EXTRABOLD  = 800
%  FW_HEAVY      = 900
% LOGPIXELSY 90

% HWND_DESKTOP  0


'===============================  
' for displaying the RGB colors 
Function RGB(sys wred,wgreen,wblue) as sys
  sys wcolor
  wcolor = wred
  wcolor = wcolor + wgreen*256
  wcolor = wcolor + wblue*65536
  Return wcolor
End Function 



'======================================== 
' draws with color gradient
SUB DrawGradient (BYVAL hDC AS DWORD)
   LOCAL rectFill AS RECT, rectClient AS RECT, fStep AS SINGLE
   local hBrush AS DWORD, lOnBand AS LONG
   GetClientRect WindowFromDC(hDC), rectClient
   fStep = rectClient.bottom / 75

   FOR lOnBand = 0 TO 50 ' 199
      SetRect rectFill, 0, lOnBand * fStep, rectClient.right + 1, (lOnBand + 1) * fStep
      ' paint the background -- change the first 2 colors R and G
      ' to vary the color gradient

    Select case MainWindBGColor
      Case 1
      ' this gives a light yellow background
       hBrush = CreateSolidBrush(rgb(255, 255, 205 - lOnBand))
      Case 2
     ' this gives a cyan background
       hBrush = CreateSolidBrush(rgb(0, 248, 255 - lOnBand))
      Case 3
      ' this gives a light green background
        hBrush = CreateSolidBrush(rgb(155, 250, 147 - lOnBand))
    End Select

      Fillrect hDC, rectFill, hBrush
      DeleteObject hBrush
   NEXT

END SUB




'==============================================================================
Function O2ApiCreateFont(szFaceName As Zstring,Byval lPointSize As long, BYVAL lWeight     AS LONG) As sys
    Dim tlf As LOGFONT
    Dim Fhdc As sys
    Dim nNum As long
    Fhdc = GetDc(%HWND_DESKTOP)
    nNum = GetDeviceCaps(Fhdc, %LOGPIXELSY)
    tlf.lfHeight         = -MulDiv(lPointSize,nNum , 72)
    tlf.lfWidth          =  0
    tlf.lfEscapement     =  0
    tlf.lfOrientation    =  0
    tlf.lfWeight         = lWeight 
    tlf.lfItalic         =  0
    tlf.lfUnderline      =  0
    tlf.lfStrikeOut      =  0
    tlf.lfCharSet        =  %ANSI_CHARSET
    tlf.lfOutPrecision   =  %OUT_TT_PRECIS
    tlf.lfClipPrecision  =  %CLIP_DEFAULT_PRECIS
    tlf.lfQuality        =  %DEFAULT_QUALITY
    tlf.lfPitchAndFamily =  %FF_DONTCARE
    tlf.lfFaceName       =  szFaceName
    ReleaseDC(%HWND_DESKTOP, Fhdc)
Function = CreateFontIndirect(@tlf)
End Function





